** Testfunktionen
IF NOT TYPE("__DATEV_ONLINE_REGISTERED")$"L" OR !__DATEV_ONLINE_REGISTERED
    oApp.oplugins.registerplugin("datev", FORCEEXT(SYS(16), "PRG"))
ENDIF

LOCAL loPlugin
loPlugin = oApp.oplugins.getplugin("datev")

IF !ISNULL(loPlugin)
    oApp.doform("dfue06")
ENDIF

#DEFINE OWN_FILE SYS(16)

#DEFINE CRLF   CHR(13)+CHR(10)

#DEFINE ERR_OK              1
#DEFINE ERR_NOTHING_DONE    0
#DEFINE ERR_FILEERROR      -1
#DEFINE ERR_DATAERROR      -2

#DEFINE ERR_EXPORT_TYPE    -4
#DEFINE ERR_CANCEL         -5
#DEFINE ERR_FILENOTFOUND   -6

EXTERNAL FILE "D:\cp-pro\goffice3\common\plugins\damo\damo_eingabe.ini"

DEFINE CLASS pluginDatev AS cPlugins OF plugins.fxp
    cValue   = "DATEV Unternehmen Online" && Bitte ndern, bei Verwendung als externes Plugin!
    nValue   = 83
    cWorkDir = "DATEV\"
    oDms     = .NULL.
    

    PROCEDURE DESTROY
        __DATEV_ONLINE_REGISTERED = .F.
        RELEASE __DATEV_ONLINE_REGISTERED

        RETURN DODEFAULT()
    ENDPROC

    PROCEDURE INIT
        PUBLIC __DATEV_ONLINE_REGISTERED
        __DATEV_ONLINE_REGISTERED = .T.

        RETURN DODEFAULT()
    ENDPROC

    PROCEDURE registerActions(toPlugin AS plugins OF plugins.prg)
        toPlugin.register(THIS, "cdataprefform:param01",      "init", "addComboitems")
        toPlugin.register(THIS, "cdataprefform:param02",      "init", "addComboitems")
        toPlugin.register(THIS, "_form:fibuexport",           "init", "addExportHandler")

        LOCAL loPlug AS pluginDMS OF SYS(16
        THIS.oDms = NEWOBJECT("plugindms", OWN_FILE, oApp.cexecutable)
        THIS.oDms.registerActions(toPlugin)
    ENDPROC

    PROCEDURE releaseActions(toPlugin AS plugins OF plugins.prg)
        IF DODEFAULT(@toPlugin)

            toPlugin.unregister(THIS, "cdataprefform:param01",      "init")
            toPlugin.unregister(THIS, "cdataprefform:param02",      "init")
            toPlugin.unregister(THIS, "_form:fibuexport",           "init")

            THIS.oDms.releaseActions(toPlugin)
        ENDIF
    ENDPROC

    PROCEDURE addExportHandler(toForm)
        WITH toForm AS FORM
            .NEWOBJECT("_datev", "_datev", "plugin_internal_datev.fxp", "", THIS)

            IF TYPE("._datev")$"O"
                ._datev.bindForm()
            ENDIF
        ENDWITH
    ENDPROC

    PROCEDURE addComboItems(toForm)
        WITH toForm
            LOCAL loCbo AS COMBOBOX

            DO CASE
                CASE UPPER(.NAME)$"PARAM01"
                    ** Rechnungseingnge
                    loCbo = .pageframe1.page3.cbosstyp4
                    loCbo.ROWSOURCE = loCbo.ROWSOURCE + ","+THIS.cValue+","+TRANSFORM(THIS.nValue)

                    ** NU-Rech Seperat
                    loCbo = .pageframe1.page3.cbosstyp5
                    loCbo.ROWSOURCE = loCbo.ROWSOURCE + ","+THIS.cValue+","+TRANSFORM(THIS.nValue)

                    ** Zahlungsausgnge
                    loCbo = .pageframe1.page3.cbosstypza
                    loCbo.ROWSOURCE = loCbo.ROWSOURCE + ","+THIS.cValue+","+TRANSFORM(THIS.nValue)


                CASE UPPER(.NAME)$"PARAM02"
                    ** Rechnungsausgnge
                    loCbo = .pageframe1.page3.cboSStyp
                    loCbo.ROWSOURCE = loCbo.ROWSOURCE + ","+THIS.cValue+","+TRANSFORM(THIS.nValue)

                    ** Zahlungseingnge
                    loCbo = .pageframe1.page3.sszetyp
                    loCbo.ROWSOURCE = loCbo.ROWSOURCE + ","+THIS.cValue+","+TRANSFORM(THIS.nValue)
            ENDCASE
        ENDWITH
    ENDPROC
ENDDEF


DEFINE CLASS _datev AS CUSTOM
    oDatev = .NULL.
    hFile  = 0

    PROCEDURE INIT (toDatev AS pluginDatev OF "plugin_internal_datev.fxp")
        IF !VARTYPE(toDatev)$"O" OR ISNULL(toDatev)
            RETURN .F.
        ENDIF

        THIS.oDatev = toDatev

        ** Prfe ob DATEV berhaupt irgendwo konfiguriert ist!
        IF !THIS.doExport("CHECK")
            RETURN .F.
        ENDIF


        IF !FILE(toDatev.cWorkDir+"eingabe.ini")
            TRY
                STRTOFILE(THIS.getDamoFile("EINGABE"), toDatev.cWorkDir+"eingabe.ini")
            CATCH TO loError
                lValid = .F.
                MESSAGEBOX(;
                    _("Die DATEV Konfigurationsdateien sind nicht im Ordner:\n"+CRLF;
                    + "%s\n\n";
                    + "zu finden. Die DATEV Initalisierung wird abgebrochen.", toDatev.cWorkDir);
                    , 16, THISFORM.CAPTION)
            ENDTRY
        ENDIF


        RETURN .T.
    ENDPROC

    FUNCTION bindForm
        BINDEVENT(THISFORM, "doExport", THIS, "doExport")
    ENDFUNC

    FUNCTION getDamoFile(tcFile)
        tcFile = UPPER(EVL(tcFile,""))

        LOCAL lcPath
        lcPath = ""

        IF VERSION(2)=2
            lcPath = "D:\cp-pro\goffice3\common\plugins\damo\"
        ENDIF

        DO CASE
            CASE tcFile$"EXE"
                lcPath = lcPath+"damo.exe"
            CASE tcFile$"INI"
                lcPath = lcPath+"damo.ini"
            CASE tcFile$"ERROR"
                lcPath = lcPath+"damo_error.tab"
            CASE tcFile$"AUSGABE"
                lcPath = lcPath+"damo_ausgabe.ini"
            CASE tcFile$"EINGABE"
                lcPath = lcPath+"damo_eingabe.ini"
        ENDCASE

        LOCAL lcFileContent
        lcFileContent = ""

        TRY
            lcFileContent = FILETOSTR(lcPath)
        CATCH TO loError
            THROW loError
        ENDTRY

        RETURN lcFileContent
    ENDFUNC

    FUNCTION doDamoConfig(tcWorkDir)
        IF VARTYPE(tcWorkDir)#"C" OR EMPTY(tcWorkDir)
            tcWorkDir = THIS.oDatev.cWorkDir
        ENDIF

        ** Wird der Konfigurationsdialog gezeigt.
        LOCAL loForm AS _form OF basectrls.vcx
        loForm = .NULL.
        loForm = NEWOBJECT("damo_config", "plugin_internal_datev.fxp", oApp.cexecutable, THIS.oDatev, tcWorkDir)
        *!*			DO FORM damo_config NAME loForm LINKED WITH THIS.oDatevBin, tcWorkDir NOSHOW

        IF TYPE("loForm")$"O" AND NOT ISNULL(loForm)
            loForm.SHOW(1)

            IF ISNULL(loForm)
                RETURN ERR_CANCEL
            ENDIF
        ELSE
            RETURN ERR_FILENOTFOUND
        ENDIF

        RETURN ERR_OK
    ENDFUNC

    PROCEDURE doExport(tcToExport, tnId, tcFile)
        **********************************************************
        ** Ablauf
        **
        ** 1   Was soll exportiert werden?
        ** 2   ist dieses Plugin dafr konfiguriert (this.nValue)
        ** 3   Arbeitsverzeichnis erstellen (/DATEV)
        **     (TODO evtl. Konfigurierbar)
        ** 4   Existieren die DAMO Dateien darin?
        ** 4.1 NEIN -> Konfigdialog zeigen und Dateien erzeugen
        ** 5   Im PARAM Konfigurierten Pfad in AUSGABE.INI setzten
        ** 6   Arbeitsverz. + Dateiname in EINGABE.INI setzten
        ** 7   Ursprnglichen Export aufrufen
        ** 7.1 Aufrufen der entsp. FKT mit Parameter (ID und PFAD)
        **********************************************************
        LOCAL lnParamID, lnCallID
        STORE 0 TO lnParamID, lnCallID

        LOCAL lcOutputPath, lcOutputFile, lcName
        STORE "" TO lcOutputPath, lcOutputFile

        ** Parameterwerte fr den Export holen
        DO CASE
            CASE tcToExport$"CHECK"
                LOCAL lValid
                lValid = INLIST(THIS.oDatev.nValue;
                    ,         oParam.param01.sstyp4;
                    ,         oParam.param02.sstyp1;
                    ,         oParam.param02.sszetyp;
                    ,         oParam.param01.sstypza)

                IF TYPE("THISFORM.lExportKasse")$"L"
                    THISFORM.lExportKasse = ;
                        oParam.param01.sstypza = THIS.oDatev.nValue ;
                        AND oParam.param01.zass AND oApp.getstatus("DTVA", .F., .F., "LICENSE")
                ENDIF

                RETURN lValid

            CASE tcToExport$"RE"
                lnParamID    = oParam.param01.sstyp4
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param01.ssdatei4))
                lcOutputFile = ALLTRIM(JUSTFNAME(oParam.param01.ssdatei4))
                lcName       = _("Rechnungseingnge")

            CASE tcToExport$"RA"
                lnParamID    = oParam.param02.sstyp1
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param02.ssdatei1))
                lcOutputFile = ALLTRIM(JUSTFNAME(oParam.param02.ssdatei1))
                lcName       = _("Rechnungsausgnge")

            CASE tcToExport$"ZE"
                lnParamID    = oParam.param02.sszetyp
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param02.sszedatei))
                lcOutputFile = ALLTRIM(JUSTFNAME(oParam.param02.sszedatei))
                lcName       = _("Zahlungseingnge")

            CASE tcToExport$"ZA"
                lnParamID    = oParam.param01.sstypza
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param01.ssdateiza))
                lcOutputFile = ALLTRIM(JUSTFNAME(oParam.param01.ssdateiza))
                lcName       = _("Zahlungsausgnge / sonstige Buchungen")

            CASE tcToExport$"KASSE"
                lnParamID    = THIS.oDatev.nValue
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param02.sszedatei))
                lcOutputFile = "export_kasse.txt"
                lcName       = _("Kassenbuch / Kontoblatt")

            CASE tcToExport$"DEB"
                lnParamID    = oParam.param02.sstyp1
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param02.ssdatei1))
                lcOutputFile = "export_debitoren.txt"
                lcName       = _("Debitoren")

            CASE tcToExport$"KRED"
                lnParamID    = oParam.param01.sstyp4
                lcOutputPath = ALLTRIM(JUSTPATH(oParam.param01.ssdatei4))
                lcOutputFile = "export_kreditoren.txt"
                lcName       = _("Kreditoren")

            OTHERWISE
                RETURN ERR_EXPORT_TYPE
        ENDCASE

        THIS.fileClose()

        IF lnParamID <> THIS.oDatev.nValue
            RETURN ERR_NOTHING_DONE
        ENDIF

        LOCAL lcWorkDir
        lcWorkDir = ADDBS(FULLPATH(THIS.oDatev.cWorkDir))

        ** Objekte erzeugen, damit in die INI Dateien
        ** geschrieben werden kann
        PRIVATE loEingabeIni AS _ini OF cpprefs
        loEingabeIni = NEWOBJECT("_ini", "cpprefs.vcx", oApp.cexecutable, lcWorkDir+"EINGABE.ini")

        PRIVATE lcPnr, lnPnr1, lnPnr2
        lcPnr  = ""
        lnPnr1 = 0
        lnPnr2 = 999999

        ** Ausgabedatei anpassen!
        lcOutputPath = ADDBS(lcOutputPath)
        lcOutputFile = EVL(lcOutputFile, tcToExport+"_ausgabe.txt")

        LOCAL lValid
        lValid = .F.

        IF !directoryX(lcOutputPath)
            MESSAGEBOX(_("Es ist ein Fehler aufgetreten."+CRLF;
                +"Der Exportpfad fr DATEV konnte nicht erstellt werden.")+CRLF+CRLF;
                +lcOutputPath, 48, _("DATEV Export"))
            RETURN ERR_FILEERROR
        ENDIF

        PRIVATE poWait AS waitload OF cpapplication
        poWait = NEWOBJECT("waitload", "cpapplication.vcx", oApp.cexecutable)
        poWait.TEXT = _("DATEV Export luft")
        poWait.lKnightRider = .T.
        poWait.SHOW()

        ** Der Datumsbereich wird als PRIVAT VAR an die kommenden
        ** Funktionen "bergeben", wenn evtl. dieser Bereich
        ** angepasst werden soll.
        PRIVATE ldVon, ldBis
        ldVon = THISFORM.cntdate.selDate.dDate1
        ldBis = THISFORM.cntdate.selDate.dDate2

        DO CASE
            CASE tcToExport$"RE"
                lnError = THIS.doExport_RE(0, lcOutputPath+lcOutputFile)

            CASE tcToExport$"RA"
                lnError = THIS.doExport_RA(0, lcOutputPath+lcOutputFile)

            CASE tcToExport$"ZE"
                lnError = THIS.doExport_ZE(0, lcOutputPath+lcOutputFile)

            CASE tcToExport$"ZA"
                lnError = THIS.doExport_ZA(0, lcOutputPath+lcOutputFile)

            CASE tcToExport$"DEB"
                lnError = THIS.doExport_DEB(0, lcOutputPath+lcOutputFile)

            CASE tcToExport$"KRED"
                lnError = THIS.doExport_KRED(0, lcOutputPath+lcOutputFile)

            CASE tcToExport$"KASSE"
                lnError = THIS.doExport_KASSE(0, lcOutputPath+lcOutputFile)
        ENDCASE

        IF !lnError = ERR_OK
            MESSAGEBOX(_("Es ist ein Fehler aufgetreten."+CRLF;
                +      "Der Export nach DATEV konnte nicht"+CRLF;
                +      "durchgefhrt werden."), 48, ("DATEV Export"))
            RETURN ERR_FILEERROR
        ENDIF

        IF !THIS.fileClose()
            MESSAGEBOX(_("Die Exportdatei im Exportverzeichnis konnte "+CRLF;
                +    "nicht geschlossen werden!"+CRLF+CRLF;
                +    "Starten Sie ggf. die Anwendung neu!"), 48, _("DATEV Export"))
            RETURN ERR_FILEERROR
        ENDIF

        THISFORM.SSDatei = lcOutputPath+lcOutputFile
        THISFORM.ssname  = lcName
        THISFORM.REFRESH()
    ENDPROC

    FUNCTION fileOpen(tcFile AS STRING)
        RETURN THIS.oDatev.fileOpen(tcFile)
    ENDFUNC

    FUNCTION fileClose()
        RETURN THIS.oDatev.fileClose()
    ENDFUNC

    FUNCTION fileWrite(tcZeile AS STRING)
        IF TYPE("poWait.CANCEL")$"L"
            poWait.inc(_("Erzeuge Exportdatei..."))
        ENDIF

        *!*	ANSI
        *!*	STRTOFILE("", "D:\test2.txt", 1)

        *!*	ANSI - Windows-1252 - Microsoft Windows!!
        *!*	STRTOFILE(CPCONVERT(CPCURRENT(),1252,""), "D:\test.txt", 1)

        *!*	ASCII - DOS LATIN 1
        *!*	STRTOFILE(CPCONVERT(CPCURRENT(),850,""), "D:\test.txt", 1)

        *!*	ASCII - DOS USA
        *!*	STRTOFILE(CPCONVERT(CPCURRENT(),437,""), "D:\test.txt", 1)

        *!*	IF !ISNULL(tcZeile)
        *!*		tcZeile = CPCONVERT(CPCURRENT(), 1252, tcZeile)
        *!*	ENDIF

        RETURN THIS.oDatev.fileWrite(tcZeile)
    ENDFUNC

    FUNCTION fileWriteLn(tcZeile AS STRING)
        RETURN THIS.fileWrite(tcZeile+CRLF)
    ENDFUNC

    *********************
    ** EXPORTE
    *********************

    FUNCTION doExport_RE(tnId, tcFile)
        LOCAL lnError
        lnError = THIS.fileOpen(tcFile)

        PRIVATE nAnzahl
        nAnzahl = 0

        IF lnError = ERR_OK
            IF !THISFORM.cntdate.check2.VALUE
                _sqlexec(_s( ;
                    "SELECT Nurkopf.belegnr, Nurkopf.jahr, Nurkopf.erfDatum, Nurkopf.knr, Nurkopf.rechnr, " + ;
                    "Nurkopf.debnum, Nurkopf.faellig, Nurkopf.ksuchname AS nuname, Nurkopf.verbucht, Nurkopf.beschreib, " + ;
                    "Nurpos.ktr, Nurpos.ktext AS TEXT, Nurpos.gp AS wert, Nurpos.soll, Nurpos.uid, Nurkopf.ok, " + ;
                    "Nurpos.kto, Nurpos.gegenkto, Nurkopf.kgegenkto, Nurkopf.steuerschl, Nurkopf.brutto, " + ;
                    "Nurkopf.ustproz, Nurkopf.ustdm, Nurkopf.buchungsdatum, steuerschluessel.fremdschl " + ;
                    "FROM  Nurkopf FULL JOIN Nurpos " + ;
                    "ON  Nurkopf.belegnr = Nurpos.belegnr " + ;
                    "AND  Nurkopf.jahr = Nurpos.jahr " + ;
                    "Inner JOIN steuerschluessel " + ;
                    "ON Nurkopf.steuerschl = steuerschluessel.stschl " + ;
                    "AND steuerschluessel.vorst = .T. " + ;
                    "WHERE Nurkopf.buchungsdatum >= {1} " + ;
                    "AND Nurkopf.buchungsdatum<= {2} " + ;
                    "AND EVL(Nurkopf.verbucht, .NULL.) IS NULL " + ;
                    "AND Nurpos.gp <> 0 " + ;
                    "AND Nurkopf.ok = .T. " + ;
                    "AND NOT RTRIM(Nurpos.postyp) IN ('TK', 'TS') " + ;
                    "ORDER BY Nurkopf.belegnr, Nurpos.kto", ;
                    ldVon, ldBis), ;
                    "kad")
            ELSE
                _sqlexec(_s( ;
                    "SELECT Nurkopf.belegnr, Nurkopf.jahr, Nurkopf.erfDatum, Nurkopf.knr, Nurkopf.rechnr, " + ;
                    "Nurkopf.debnum, Nurkopf.faellig, Nurkopf.ksuchname AS nuname, Nurkopf.verbucht, Nurkopf.beschreib, " + ;
                    "Nurpos.ktr, Nurpos.ktext AS TEXT, Nurpos.gp AS wert, Nurpos.soll, Nurpos.uid, Nurkopf.ok, " + ;
                    "Nurpos.kto, Nurpos.gegenkto, Nurkopf.kgegenkto, Nurkopf.steuerschl, Nurkopf.brutto, " + ;
                    "Nurkopf.ustproz, Nurkopf.ustdm, Nurkopf.buchungsdatum, steuerschluessel.fremdschl " + ;
                    "FROM  Nurkopf FULL JOIN Nurpos " + ;
                    "ON  Nurkopf.belegnr = Nurpos.belegnr " + ;
                    "AND  Nurkopf.jahr = Nurpos.jahr " + ;
                    "Inner JOIN steuerschluessel " + ;
                    "ON Nurkopf.steuerschl = steuerschluessel.stschl " + ;
                    "AND steuerschluessel.vorst = .T. " + ;
                    "WHERE Nurkopf.buchungsdatum >= {1} " + ;
                    "AND Nurkopf.buchungsdatum <= {2} " + ;
                    "AND Nurpos.gp <> 0 " + ;
                    "AND Nurkopf.ok = .T. " + ;
                    "AND NOT RTRIM(Nurpos.postyp) IN ('TK', 'TS') " + ;
                    "ORDER BY Nurkopf.belegnr, Nurpos.kto", ;
                    ldVon, ldBis), ;
                    "kad")
            ENDIF

            THIS.fileWriteLn("CP-Pro Rechnungeingnge "+DTOC(ldVon)+"-"+DTOC(ldBis))


            LOCAL lnOldBeleg
            lnOldBeleg = -1

            SELECT ("kad")
            GOTO TOP IN ("kad")
            SCAN
                poWait.inc()

                IF lnOldBeleg <> kad.belegnr
                    IF !EMPTY(kad.kgegenkto)
                        THIS.fileWriteLn(""+;                  && Whrung (wird nicht explizit bergeben)
                        ";"+IIF(kad.brutto>=0,"-","+")+;       && Soll Haben Kennzeichen
                        ";"+TRANSFORM(ABS(kad.brutto))+;       && Umsatz mit Komma
                        ";"+ALLTRIM(kad.fremdschl)+;           && Steuerschlssel
                        ";"+LEFT(ALLTRIM(kad.kgegenkto),9)+;   && Gegenkonto
                        ";"+ALLTRIM(STR(kad.belegnr))+;        && Rechnungsnummer (Belegfeld 1)
                        ";"+;                                  && Belegfeld 2 (auch Flligkeitsdatum) TTMM
                        ";"+PADL(DAY(kad.buchungsdatum),2,"0")+PADL(MONTH(kad.buchungsdatum),2,"0")+;         && Buchungsdatum
                        ";"+LEFT(ALLTRIM(STR(kad.debnum)),9)+; && Konto
                        ";"+RIGHT(TRANSFORM(kad.ktr),8)+;	   && Kostfeld1 ( KTR)
                        ";"+;								   && Kostfeld2
                        ";"+;								   && Kostmenge
                        ";"+;								   && Skonto
                        ";"+LEFT(ALLTRIM(kad.rechnr)+" "+ALLTRIM(kad.nuname),30)+;     && Buchungstext
                        ";0"; && Festsetzung deaktivieren
                        )


                        nAnzahl = nAnzahl +1
                    ENDIF
                    lnOldBeleg = kad.belegnr

                    _sqlexec(;
                        _s("UPDATE posten ";
                        +  "   SET verbucht = DATE() ";
                        +  " WHERE debcred  = 2 ";
                        +  "   AND rechidx  = {1}";
                        +  "   AND rechjahr = {2}";
                        +  "   AND rechidx != 0";
                        , kad.belegnr, kad.jahr))
                ENDIF

                LOCAL lnBruttoNurpos, lnBruttoNurkopf
                lnBruttoNurkopf = ABS(kad.brutto)
                lnBruttoNurpos  = ROUND(ABS(kad.wert) * (100 + IIF(EMPTY(kad.kgegenkto), kad.ustproz, 0)) / 100, 2)

                THIS.fileWriteLn(""+;                  && Whrung (wird nicht explizit bergeben)
                ";"+IIF(kad.soll=1,IIF(kad.wert>=0,"+","-"),IIF(kad.wert>=0,"-","+"))+; && Soll Haben Kennzeichen
                ";"+TRANSFORM(IIF(EMPTY(kad.kgegenkto); && Wenn nur eine Buchung (also kein Verrechnungskonto)
                , lnBruttoNurkopf;       && Brutto von nurkopf verwenden
                , lnBruttoNurpos))+;     && Brutto von nurkpos verwenden
                ";"+IIF(EMPTY(kad.kgegenkto),ALLTRIM(kad.fremdschl),"")+; && Steuerschlssel
                ";"+ALLTRIM(kad.gegenkto)+;            && Gegenkonto
                ";"+ALLTRIM(STR(kad.belegnr))+;        && Rechnungsnummer (Belegfeld 1)
                ";"+;                                  && Belegfeld 2 (auch Flligkeitsdatum) TTMM
                ";"+PADL(DAY(kad.buchungsdatum),2,"0")+PADL(MONTH(kad.buchungsdatum),2,"0")+;      && Buchungsdatum
                ";"+LEFT(ALLTRIM(kad.kto),9)+;         && Konto
                ";"+RIGHT(TRANSFORM(kad.ktr),8)+;	   && Kostfeld1 ( KTR)
                ";"+;								   && Kostfeld2
                ";"+;								   && Kostmenge
                ";"+;								   && Skonto
                ";"+LEFT(ALLTRIM(kad.rechnr)+" "+ALLTRIM(kad.nuname),30)+;     && Buchungstext
                ";0"; && Festsetzung deaktivieren
                )
                nAnzahl = nAnzahl +1
            ENDSCAN

            * Verbucht-Datum setzen, geht aus irgendeinem Grunde nicht im View
            IF !THISFORM.cntdate.check2.VALUE
                _sqlexec(_s( ;
                    "UPDATE Nurkopf SET verbucht=DATE() "+;
                    "WHERE buchungsdatum >= {1} AND buchungsdatum <= {2} "+;
                    "AND EVL(verbucht, .NULL.) IS NULL AND ok = .T." ;
                    , ldVon, ldBis))
            ELSE
                _sqlexec(_s( ;
                    "UPDATE Nurkopf SET verbucht=DATE() "+;
                    "WHERE buchungsdatum >= {1} AND buchungsdatum <= {2} "+;
                    "AND ok = .T." ;
                    , ldVon, ldBis))
            ENDIF

            THISFORM.oreport.newDataSource("kad", .F., "RE_DFUE_PROT1")
            THISFORM.oreport.PRINT()
            USE IN SELECT("kad")

        ENDIF
        THIS.fileClose()

        SET COLLATE TO "GERMAN"

        RETURN lnError
    ENDFUNC

    FUNCTION doExport_RA(tnId, tcFile)
        LOCAL lnError
        lnError = THIS.fileOpen(tcFile)

        IF lnError = ERR_OK
            LOCAL lnSumZahl, lnSumRech
            STORE 0 TO lnSumZahl, lnSumRech

            PRIVATE nAnzahl
            nAnzahl = 0

            LOCAL ldVerbucht
            ldVerbucht = IIF(!THISFORM.cntdate.check2.VALUE;
                , {^1900-01-01};
                , {^2999-12-31})

            _sqlexec(_s( ;
                "SELECT * FROM (" + ;
                "SELECT rechnr, CAST('' AS CHAR(10)) as belegnr, rechkopf.jahr, arnum, rechkopf.ktr, rechkopf.docnr as aufnr, rechkopf.knr, ksuchname, " + ;
                "LEFT(MLINE(objektlang,1),80) AS objekt, " + ;
                "datum, netto, ustdm, brutto, nettoa, ustdma, bruttoa, ustdmc, bruttoc, " + ;
                "bruttoa1, bruttob, nettoa1, nettob, ustdma1, ustdmb, " + ;
                "faellig, faellig1, faellig2, ustproza AS ustproz, sk1, sk2, tageart1, " + ;
                "tageart2, tageart, tage1, tage2, tage3, rechkopf.gb1, " + ;
                "factordeb, konto, ok, verbucht, fremdschl, steuerschl, nvl(ktr.datevkto, '') as datevkto, rechkopf.uebertyp " + ;
                "FROM rechkopf " + ;
                "Inner JOIN kunden " + ;
                "ON rechkopf.knr = kunden.debnum " + ;
                "LEFT OUTER JOIN steuerschluessel " + ;
                "ON rechkopf.steuerschl = steuerschluessel.stschl " + ;
                "AND steuerschluessel.vorst = .F. " + ;
                "LEFT JOIN ktr ON ktr.ktr = rechkopf.ktr and ktr.jahr = rechkopf.jahr " + ;
                "WHERE rechkopf.datum >= {1} " + ;
                "AND rechkopf.datum <= {2} " + ;
                "AND ok = .T. " + ;
                "AND (verbucht < {3} OR verbucht IS NULL) " + ;
                "UNION (SELECT rechnr, CAST(gutnr AS CHAR(10)) AS belegnr, gutkopf.jahr, -1 AS arnum, gutkopf.ktr, 0000000000 AS aufnr, gutkopf.knr, ksuchname, " + ;
                "LEFT(MLINE(objektlang,1),80) AS objekt, datum, netto, ustdm, " + ;
                "brutto, netto AS nettoa, ustdm AS ustdma, brutto AS bruttoa, ustdm AS ustdmc, " + ;
                "brutto AS bruttoc, " + ;
                "0.0 AS bruttoa1, 0.0 AS bruttob, 0.0 AS nettoa1, " + ;
                "0.0 AS nettob, 0.0 AS ustdma1, 0.0 AS ustdmb, " + ;
                "datum AS faellig, datum AS faellig1, datum AS faellig2, " + ;
                "gutkopf.ustproz, 0 AS sk1, 0 AS sk2, 0 AS tageart1, 0 AS tageart2, " + ;
                "0 AS tageart, 0 AS tage1, 0 AS tage2, 0 AS tage3, gutkopf.gb1, " + ;
                "factordeb, konto, ok, verbucht, fremdschl, steuerschl, nvl(ktr.datevkto, '') as datevkto, 0 as uebertyp " + ;
                "FROM gutkopf " + ;
                "Inner JOIN kunden " + ;
                "ON gutkopf.knr = kunden.debnum " + ;
                "LEFT OUTER JOIN steuerschluessel " + ;
                "ON gutkopf.steuerschl = steuerschluessel.stschl " + ;
                "AND steuerschluessel.vorst = .F. " + ;
                "LEFT JOIN ktr ON ktr.ktr = gutkopf.ktr and ktr.jahr = gutkopf.jahr " + ;
                "WHERE gutkopf.datum >= {1} " + ;
                "AND gutkopf.datum <= {2} " + ;
                "AND ok = .T. " + ;
                "AND (verbucht < {3} OR verbucht IS NULL) ) " + ;
                ") AS result " + ;
                "ORDER BY rechnr", ;
                ldVon, ldBis, ldVerbucht), ;
                "kad")

            LOCAL lcaPostUmbu AS ca_posten_umbuchung OF datacls
            lcaPostUmbu = NEWOBJECT("ca_posten_umbuchung", "datacls.vcx", oApp.cexecutable)
            lcaPostUmbu.ALIAS = "posten_umbuchung"
            lcaPostUmbu.param_aufnr  = 0
            lcaPostUmbu.param_uebertyp = 0
            lcaPostUmbu.param_datum  = {}
            lcaPostUmbu.param_jahr   = oApp.Gjahr
            lcaPostUmbu.param_rechnr = 0
            lcaPostUmbu.param_ktr    = 0
            **lcaPostUmbu.param_debcred  = 1
            lcaPostUmbu.CURSORFILL()

            THIS.fileWriteLn("CP-Pro Rechnungsausgnge "+DTOC(ldVon)+"-"+DTOC(ldBis))

            LOCAL lcXMLPath, lcXMLTime
            lcXMLTime = TTOC(DATETIME(),1)
            lcXMLPath = ADDBS(JUSTPATH(tcFile)) + lcXMLTime

            directoryX(lcXMLPath)

            LOCAL lcDocuments
            lcDocuments = ""

            SET FILTER TO ok AND (THISFORM.cntdate.check2.VALUE OR EMPTY(NVL(verbucht, {}))) IN ("kad")
            GOTO TOP IN ("kad")
            SCAN
                **************************************************************
                ** BITTEST(bitflag, 6) -> relevante Dateien fr DATEV-Online
                **
                ** BITTEST(bitflag, 5) == .T. -> DATEV-Online XML-File
                ** BITTEST(bitflag, 5) == .F. -> PDF-Export
                **************************************************************
                LOCAL lcIsXmlFileFilter, lcIsPdfFileFilter
                lcIsXmlFileFilter = "BITTEST(bitflag, 5) == .T."
                lcIsPdfFileFilter = "BITTEST(bitflag, 5) == .F."

                _sqlexec(;
                    _s("SELECT h.action, h.histid, h.bitflag";
                    +  "  FROM dochist as h ";
                    +  " WHERE docnr = {1} ";
                    +  "   AND docjahr = {2} ";
                    +  "   AND uebertyp = {3}";
                    +  "   AND BITTEST(bitflag, 6) == .T. ";
                    +  " ORDER BY h.datum DESC";
                    ,  kad.rechnr, kad.jahr, IIF(kad.arnum < 0, 5, 6));
                    ,  "curDochist")

                LOCAL lcFilePDF
                lcFilePDF = ""

                SELECT ("curDochist")
                LOCATE FOR &lcIsPdfFileFilter.
                IF FOUND("curDochist")
                    LOCAL lcaDocHistId AS ca_dochistid OF cpprefs.vcx
                    lcaDocHistId = NEWOBJECT("ca_dochistid", "cpprefs.vcx", oApp.cexecutable)
                    lcaDocHistId.SELECTCMD = _s("SELECT * FROM dochistid WHERE hid == {1}", curDochist.histid)
                    lcaDocHistId.CURSORFILL(.T., .F.)

                    lcFilePDF = TEXTMERGE([<<ADDBS(lcXMLPath)>><<IIF(kad.arnum<0,"Gutschrift","Rechnung")>>_<<kad.rechnr>>.pdf])

                    IF (FILE(lcFilePDF))
                        ERASE (lcFilePDF)
                    ENDIF

                    LOCAL lcContent
                    lcContent = CAST(lcaDocHistId.getValue("content") AS M)
                    IF lcaDocHistId.getValue("histType") == 1
                        lcContent = FILETOSTR(lcContent)
                    ENDIF

                    STRTOFILE(lcContent, lcFilePDF)
                ENDIF

                LOCAL lcFileXML
                lcFileXML = ""

                SELECT ("curDochist")
                LOCATE FOR &lcIsXmlFileFilter.
                IF FOUND("curDochist")
                    LOCAL lcaDocHistId AS ca_dochistid OF cpprefs.vcx
                    lcaDocHistId = NEWOBJECT("ca_dochistid", "cpprefs.vcx", oApp.cexecutable)
                    lcaDocHistId.SELECTCMD = _s("SELECT * FROM dochistid WHERE hid == {1}", curDochist.histid)
                    lcaDocHistId.CURSORFILL(.T., .F.)

                    lcFileXML = TEXTMERGE([<<ADDBS(lcXMLPath)>><<IIF(kad.arnum<0,"Gutschrift","Rechnung")>>_<<kad.rechnr>>.xml])

                    IF (FILE(lcFileXML))
                        ERASE (lcFileXML)
                    ENDIF

                    LOCAL lcContent
                    lcContent = CAST(lcaDocHistId.getValue("content") AS M)
                    IF lcaDocHistId.getValue("histType") == 1
                        lcContent = FILETOSTR(lcContent)
                    ENDIF

                    STRTOFILE(lcContent, lcFileXML, 4)
                ENDIF

                IF !EMPTY(lcFileXML)
                    TEXT TO lcDocuments TEXTMERGE NOSHOW ADDITIVE
		<document>
			<extension xsi:type="Invoice" datafile="<<JUSTFNAME(lcFileXML)>>">
				<property key="InvoiceType" value="Outgoing"/>
			</extension>
                    ENDTEXT

                    IF !EMPTY(lcFilePDF)
                        TEXT TO lcDocuments TEXTMERGE NOSHOW ADDITIVE
			<extension xsi:type="File" name="<<JUSTFNAME(lcFilePDF)>>"/>
                        ENDTEXT
                    ENDIF

                    TEXT TO lcDocuments TEXTMERGE NOSHOW ADDITIVE
		</document>

                    ENDTEXT
                ENDIF

                USE IN SELECT("dochist")
                USE IN SELECT("curDochist")


                THIS.fileWriteLn( ""+;                 && Whrung (wird nicht explizit bergeben)
                ";"+IIF(kad.arnum<0 AND kad.brutto>0 OR kad.arnum>=0 AND kad.brutto<0,"+","-")+; && Soll Haben Kennzeichen
                ";"+TRANSFORM(ABS(kad.brutto))+;       && Umsatz mit Komma
                ";"+;                                  && keinen Steuerschlssel bei Umstzen da Automatikkonten
                ";"+ALLTR(kad.datevkto)+;              && Gegenkonto
                ";"+ALLTR(STR(kad.rechnr))+;           && Rechnungsnummer (Belegfeld 1)
                ";"+ALLTR(kad.belegnr)+;               && Belegfeld 2 (auch Flligkeitsdatum) TTMM
                ";"+PADL(DAY(kad.datum),2,"0")+PADL(MONTH(kad.datum),2,"0")+;      && Buchungsdatum
                ";"+LEFT(ALLTRIM(kad.Konto),9)+;       && Konto
                ";"+RIGHT(TRANSFORM(kad.ktr),8)+;	   && Kostfeld1 ( KTR)
                ";"+;								   && Kostfeld2
                ";"+;								   && Kostmenge
                ";"+;								   && Skonto
                ";"+ALLTRIM(LEFT(kad.objekt,30));      && Buchungstext
                )

                nAnzahl = nAnzahl + 1

                IF kad.arnum >=98 AND oParam.param02.ssarbuch && Erweiterte Buchungsstze fr Abschlagrechnungen
                    * Bercksichtigung von Rckbuchungen bei Schlurechnungen
                    LOCAL lnJahrSave
                    lnJahrSave = lcaPostUmbu.param_jahr

                    lcaPostUmbu.param_aufnr    = kad.aufnr && docnr AS aufnr!!
                    lcaPostUmbu.param_uebertyp = kad.uebertyp
                    lcaPostUmbu.param_datum  = kad.datum
                    lcaPostUmbu.param_jahr   = kad.jahr
                    lcaPostUmbu.param_rechnr = kad.rechnr
                    lcaPostUmbu.param_ktr    = kad.ktr

                    lcaPostUmbu.CURSORREFRESH()

                    lcaPostUmbu.param_jahr = lnJahrSave

                    STORE 0.00 TO lnSumZahl, lnSumRech

                    CALCULATE SUM(-betrag) FOR !SollHaben TO lnSumRech IN (lcaPostUmbu.ALIAS)
                    CALCULATE SUM( betrag) FOR  SollHaben TO lnSumZahl IN (lcaPostUmbu.ALIAS)

                    *Rckbuchung bereits fakturierte Abschlagsrechnungen
                    IF lnSumRech - lnSumZahl <> 0
                        THIS.fileWriteLn(""+;                     && Whrung (wird nicht explizit bergeben)
                        ";"+IIF(lnSumRech-lnSumZahl<0,"+","-")+;   && Soll Haben Kennzeichen
                        ";"+TRANSFORM(ABS(lnSumRech-lnSumZahl))+; && Umsatz mit Komma
                        ";"+;                                     && keinen Steuerschlssel da Netto-Buchung und Automatikkonto
                        ";"+LEFT(ALLTRIM(oParam.param02.ssabschlag),9)+;   && Gegenkonto
                        ";"+ALLTRIM(STR(kad.rechnr))+;         && Rechnungsnummer (Belegfeld 1)
                        ";"+ALLTR(kad.belegnr)+;               && Belegfeld 2
                        ";"+PADL(DAY(kad.datum),2,"0")+PADL(MONTH(kad.datum),2,"0")+;         && Buchungsdatum
                        ";"+LEFT(ALLTRIM(kad.Konto),9)+;       && Konto
                        ";"+RIGHT(TRANSFORM(kad.ktr),8)+;	   && Kostfeld1 ( KTR)
                        ";"+;								   && Kostfeld2
                        ";"+;								   && Kostmenge
                        ";"+;								   && Skonto
                        ";"+ALLTRIM(LEFT(kad.objekt,30));      && Buchungstext
                        )
                        nAnzahl = nAnzahl + 1
                    ENDIF
                    IF lnSumZahl <> 0
                        THIS.fileWriteLn(""+;                  && Whrung (wird nicht explizit bergeben)
                        ";"+IIF(lnSumZahl,"-","+")+; 	       && Soll Haben Kennzeichen
                        ";"+TRANSFORM(ABS(lnSumZahl))+;        && Umsatz mit Komma
                        ";"+;                                  && keinen Steuerschlssel bei Automatikkonten
                        ";"+LEFT(ALLTRIM(oParam.param02.sserhaz),9)+;   && Gegenkonto
                        ";"+ALLTRIM(STR(kad.rechnr))+;         && Rechnungsnummer (Belegfeld 1)
                        ";"+ALLTR(kad.belegnr)+;               && Belegfeld 2
                        ";"+PADL(DAY(kad.datum),2,"0")+PADL(MONTH(kad.datum),2,"0")+;         && Buchungsdatum
                        ";"+LEFT(ALLTRIM(kad.Konto),9)+;       && Konto
                        ";"+RIGHT(TRANSFORM(kad.ktr),8)+;	   && Kostfeld1 ( KTR)
                        ";"+;								   && Kostfeld2
                        ";"+;								   && Kostmenge
                        ";"+;								   && Skonto
                        ";"+ALLTRIM(LEFT(kad.objekt,30));     && Buchungstext
                        )
                        nAnzahl = nAnzahl + 1

                    ENDIF
                ENDIF

                SELECT kad
            ENDSCAN

            LOCAL lcDocument
            TEXT TO lcDocument TEXTMERGE NOSHOW
<?xml version="1.0" encoding="utf-8"?>
<archive version="4.0"
         generatingSystem="CP-Pro Office 3"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
         xsi:schemaLocation="http://xml.datev.de/bedi/tps/document/v04.0 document_v040.xsd"
         xmlns="http://xml.datev.de/bedi/tps/document/v04.0">
	<header>
		<date><<TTOC(DATETIME(), 3)>></date>
		<description>Rechnungen aus Gerstbau Office</description>
	</header>
	<content>
		<<lcDocuments>>
	</content>
</archive>
            ENDTEXT

            STRTOFILE(STRCONV(STRCONV(lcDocument,1),9), ADDBS(lcXMLPath)+"document.xml", 4)

            LOCAL lcDatevOnlinePath
            lcDatevOnlinePath = ADDBS(ADDBS(JUSTPATH(tcFile)) + "DATEV_ONLINE")

            IF !directoryX(lcDatevOnlinePath)
                RETURN ERR_FILEERROR
            ENDIF

            LOCAL loArchive AS carchive OF dfpug_zip.vcx
            loArchive = NEWOBJECT("carchive", "dfpug_zip.vcx", oApp.cexecutable)
            loArchive.overridefile = 2
            loArchive.createarchive(lcXMLPath, "*.*", lcDatevOnlinePath+lcXMLTime+".zip", 9, .F., "")

            THISFORM.oreport.newDataSource("kad", .F., "RA_DFUE_PROT1")
            THISFORM.oreport.PRINT()
            USE IN SELECT("kad")

            lcaPostUmbu.RELEASE()
            lcaPostUmbu = .NULL.

            IF lnError = ERR_OK
                IF !THISFORM.cntdate.check2.VALUE
                    _sqlexec(_s( ;
                        "UPDATE rechkopf SET verbucht=DATE() WHERE datum >= {1} AND " + ;
                        "datum <= {2} AND EVL(verbucht, .NULL.) IS NULL AND ok = .T.", ;
                        ldVon, ldBis))
                    _sqlexec(_s( ;
                        "UPDATE gutkopf  SET verbucht=DATE() WHERE datum >= {1} AND " + ;
                        "datum <= {2} AND EVL(verbucht, .NULL.) IS NULL AND ok = .T.", ;
                        ldVon, ldBis))
                    _sqlexec(_s( ;
                        "UPDATE posten   SET verbucht=DATE() WHERE debcred = 1 AND " + ;
                        "buchdatum >= {1} AND buchdatum <= {2} AND EVL(verbucht, .NULL.) IS NULL " + ;
                        "AND (rechidx <> 0 OR gutschidx <> 0)", ;
                        ldVon, ldBis))
                ELSE
                    _sqlexec(_s( ;
                        "UPDATE rechkopf SET verbucht=DATE() WHERE datum >= {1} " + ;
                        "AND datum <= {2} AND ok = .T.", ;
                        ldVon, ldBis))
                    _sqlexec(_s( ;
                        "UPDATE gutkopf  SET verbucht=DATE() WHERE datum >= {1} " + ;
                        "AND datum <= {2} AND ok = .T.", ;
                        ldVon, ldBis))
                    _sqlexec(_s( ;
                        "UPDATE posten   SET verbucht=DATE() WHERE debcred = 1 AND " + ;
                        "(rechidx <> 0 OR gutschidx <> 0) AND buchdatum >= {1} " + ;
                        "AND buchdatum <= {2}", ;
                        ldVon, ldBis))
                ENDIF
            ENDIF
        ENDIF

        THIS.fileClose()

        SET COLLATE TO "GERMAN"

        RETURN lnError
    ENDFUNC

    FUNCTION doExport_ZA(tnId, tcFile)
        LOCAL lnError
        lnError = THIS.fileOpen(tcFile)

        PRIVATE nAnzahl
        nAnzahl = 0

        IF lnError = ERR_OK
            LOCAL lcKontoFilter, lcKontoTxt
            lcKontoFilter = ""
            lcKontoTxt    = ""
            IF !EMPTY(THISFORM.cKontoVon)
                IF EMPTY(THISFORM.cKontoBis)
                    lcKontoFilter = [ AND ( ALLTRIM(posten.buchkto) == "] + ALLTRIM(THISFORM.cKontoVon) + ["];
                        +           [ OR    ALLTRIM(CAST(IIF(posten.gegenkto<>0,posten.gegenkto,posten.knr) AS VARCHAR(10))) == "] + ALLTRIM(THISFORM.cKontoVon) + [" )]
                    lcKontoTxt = " und Buchungskonto " + ALLTRIM(THISFORM.cKontoVon)
                ELSE
                    lcKontoFilter = [ AND ( BETWEEN(ALLTRIM(posten.buchkto), "] + ALLTRIM(THISFORM.cKontoVon) + [", "] + ALLTRIM(THISFORM.cKontoVon) + [")];
                        +           [ OR    BETWEEN(ALLTRIM(CAST(IIF(posten.gegenkto<>0,posten.gegenkto,posten.knr) AS VARCHAR(10))), "] + ALLTRIM(THISFORM.cKontoVon) + [", "] + ALLTRIM(THISFORM.cKontoVon) + [") )]
                    lcKontoTxt = " und Buchungskonto von " + ALLTRIM(THISFORM.cKontoVon) + " bis " + ALLTRIM(THISFORM.cKontoBis)
                ENDIF
            ENDIF

            _sqlexec(_s( ;
                "SELECT posten.*, banken1.SORT, steuerschluessel.fremdschl " + ;
                "FROM posten " + ;
                "LEFT OUTER JOIN banken1 ON posten.banknr = banken1.banknr " + ;
                "LEFT OUTER JOIN steuerschluessel " + ;
                "ON  posten.stschl = steuerschluessel.stschl " + ;
                "AND (posten.debcred=1 AND steuerschluessel.vorst = .F. " + ;
                "OR NOT posten.debcred IN(1, 9) AND steuerschluessel.vorst = .T.) " + ;
                "WHERE rechidx = 0 AND gutschidx = 0 " + ;
                "AND posten.buchdatum >= {1} " + ;
                "AND posten.buchdatum <= {2} " + ;
                "AND NOT posten.debcred IN(1, 9) " + ;
                lcKontoFilter + " " + ;
                "ORDER BY banken1.SORT, posten.banknr, posten.buchdatum, posten.rechnr ", ;
                ldVon, ldBis), ;
                "kad")


            THIS.fileWriteLn(_("CP-Pro Zahlungsausgnge und sonstige %s-%s %s", DTOC(ldVon), DTOC(ldBis), lcKontoTxt))

            SET FILTER TO THISFORM.cntdate.check2.VALUE OR EMPTY(NVL(verbucht, {})) IN ("kad")
            GOTO TOP IN ("kad")
            SCAN
                nAnzahl = nAnzahl + 1

                THIS.fileWriteLn(""+;                          && Whrung (wird nicht explizit bergeben)
                ";"+IIF((kad.zahlung>0 AND !kad.SollHaben) OR (kad.zahlung<0 AND kad.SollHaben),"+","-")+;       && Soll Haben Kennzeichen
                ";"+TRANSFORM(ABS(kad.zahlung))+;      && Umsatz mit Komma
                ";"+IIF(!ISNULL(kad.fremdschl),ALLTRIM(kad.fremdschl),"")+;           && Steuerschlssel
                ";"+LEFT(ALLTRIM(kad.buchkto),9)+;     && Gegenkonto
                ";"+ALLTRIM(STR(kad.rechnr))+;         && Rechnungsnummer (Belegfeld 1)
                ";"+ALLTRIM(kad.beleg)+;               && Belegfeld 2 (auch Flligkeitsdatum) TTMM
                ";"+PADL(DAY(kad.buchdatum),2,"0")+PADL(MONTH(kad.buchdatum),2,"0")+;         && Buchungsdatum
                ";"+ALLTRIM(TRANSFORM(EVL(kad.gegenkto,kad.knr)))+;       && Konto
                ";"+RIGHT(TRANSFORM(kad.ktr),8)+;	   && Kostfeld1 ( KTR)
                ";"+;								   && Kostfeld2
                ";"+;								   && Kostmenge
                ";"+TRANSFORM(ABS(kad.skonto))+;	   && Skonto
                ";"+ALLTRIM(LEFT(kad.TEXT,30))+;     && Buchungstext
                ";0"; && Festsetzung deaktivieren
                )
            ENDSCAN

            THISFORM.oreport.newDataSource("kad", .F., "ZA_DFUE_PROT1")
            THISFORM.oreport.PRINT()

            USE IN SELECT("kad")

            IF lnError = ERR_OK
                IF THISFORM.cntdate.check2.VALUE = .F.
                    _sqlexec(_s( ;
                        "UPDATE posten   SET verbucht=DATE() WHERE NOT debcred IN(1, 9)  AND " + ;
                        "buchdatum >= {1} AND buchdatum <= {2} AND EVL(verbucht, .NULL.) IS NULL " + ;
                        "AND rechidx = 0 AND gutschidx = 0" + lcKontoFilter, ;
                        ldVon, ldBis))
                ELSE
                    _sqlexec(_s( ;
                        "UPDATE posten   SET verbucht=DATE() WHERE NOT debcred IN(1, 9)  AND " + ;
                        "rechidx = 0 AND gutschidx = 0 AND buchdatum >= {1} AND " + ;
                        "buchdatum <= {2}" + lcKontoFilter, ;
                        ldVon, ldBis))
                ENDIF
            ENDIF
        ENDIF

        THIS.fileClose()

        SET COLLATE TO "GERMAN"

        RETURN lnError
    ENDFUNC

    FUNCTION doExport_KASSE(tnId, tcFile)
        LOCAL lcFile
        lcFile = FORCEPATH("export_za.txt", JUSTPATH(tcFile))

        LOCAL lnError
        ** Erzeuge ZA Datei
        lnError = THIS.doExport_ZA(0, lcFile)

        IF lnError >= ERR_NOTHING_DONE
            LOCAL lcExportData

            ** Lese die Ausgabedatei und speichere deren Inhalt
            ** ignoriere die erste Zeile
            IF FILE(lcFile)
                lcExportData = STREXTRACT(FILETOSTR(lcFile), CRLF)
            ENDIF

            ** Dateiname zurcksetzen
            lcFile = FORCEPATH("export_ze.txt", JUSTPATH(tcFile))

            ** Erzeuge ZE Datei
            lnError = THIS.doExport_ZE(0, lcFile)

            IF lnError = ERR_OK AND FILE(lcFile)
                ** Lese die Ausgangsdatei und speichere deren Inhalt zusammen mit den Daten aus dem EXPORT_ZA
                ** ignoriere die erste Zeile
                lcExportData = lcExportData + STREXTRACT(FILETOSTR(lcFile), CRLF)
            ENDIF

            LOCAL lcKontoTxt
            lcKontoTxt = ""
            IF EMPTY(THISFORM.cKontoBis)
                lcKontoTxt = " " + _("und Buchungskonto %s" , ALLTRIM(THISFORM.cKontoVon))
            ELSE
                lcKontoTxt = " " + _("und Buchungskonto von %s bis %s";
                    , ALLTRIM(THISFORM.cKontoVon), ALLTRIM(THISFORM.cKontoBis))
            ENDIF

            lcExportData = _("CP-Pro Kassenbuch %s-%s %s", DTOC(ldVon), DTOC(ldBis), lcKontoTxt) +CRLF;
                + lcExportData
            STRTOFILE(EVL(lcExportData, ""), tcFile, 0)

        ENDIF

        RETURN lnError
    ENDFUNC

    FUNCTION doExport_DEB(tnId, tcFile)
        LOCAL lnError
        lnError = THIS.fileOpen(tcFile)

        IF lnError = ERR_OK
            LOCAL lAlle
            lAlle = THISFORM.cntdate.check2.VALUE

            SET COLLATE TO "MACHINE"  && Sonst kommen manchmal nicht alle Daten raus

            IF THISFORM.cntStm.opt1.VALUE = 1
                _sqlexec(_s( ;
                    "SELECT kunden.*, mahntxt.* FROM kunden " + ;
                    "Inner JOIN mahntxt " + ;
                    "ON  (ALLTRIM(mahntxt.ktext) == ALLTRIM(IIF(ALLTRIM(kunden.guttxt)=='',{4},kunden.guttxt))) " + ;
                    "WHERE debnum <> 0 " + ;
                    "AND (debnum IN " + ;
                    "(SELECT knr FROM rechkopf " + ;
                    "WHERE rechkopf.datum >= {1} " + ;
                    "AND rechkopf.datum<= {2} " + ;
                    "AND (EVL(rechkopf.verbucht, .NULL.) IS NULL OR {3} = .T.) " + ;
                    "AND rechkopf.ok = .T. ) " + ;
                    "OR debnum IN " + ;
                    "(SELECT knr FROM  gutkopf " + ;
                    "WHERE gutkopf.datum >= {1} " + ;
                    "AND gutkopf.datum<= {2} " + ;
                    "AND (EVL(gutkopf.verbucht, .NULL.) IS NULL OR {3} = .T.) " + ;
                    "AND gutkopf.ok = .T. ) ) " + ;
                    "ORDER BY debnum", ;
                    ldVon, ldBis, lAlle, oParam.param02.mahnprofil), ;
                    "kad")
            ELSE
                _sqlexec(_s( ;
                    "SELECT kunden.*, mahntxt.* FROM kunden " + ;
                    "Inner JOIN mahntxt " + ;
                    "ON  (ALLTRIM(mahntxt.ktext) == ALLTRIM(IIF(ALLTRIM(kunden.guttxt)=='',{1},kunden.guttxt))) " + ;
                    "WHERE typ = 2 " + ;
                    "ORDER BY debnum", ;
                    oParam.param02.mahnprofil), ;
                    "kad")
            ENDIF

            THIS.fileWriteLn(_("CP-Pro Debitoren %s-%s %s", DTOC(ldVon), DTOC(ldBis)))

            GOTO TOP
            SCAN
                THIS.fileWriteLn(LEFT(TRANSFORM(kad.debnum),9)+ ;	&& Debitorennummer
                ";"+LEFT(ALLTRIM(kad.NAME),40)+; 			&& Name 1
                ";"+IIF(!EMPTY(kad.adresse2),LEFT(ALLTRIM(kad.adresse1),40),"")+; 			&& Name2
                ";"+LEFT(ALLTRIM(kad.suchname),15)+; 		&& Kurzbezeichnung
                ";"+LEFT(ALLTRIM(kad.ustid),15)+; 			&& USTID
                ";"+LEFT(ALLTRIM(IIF(!EMPTY(kad.adresse2),kad.adresse2,kad.adresse1)),40)+; && Strae
                ";"+;										&& Postfach
                ";"+LEFT(ALLTRIM(THISFORM.GetString(kad.plz,1)),10)+; 	&& PLZ
                ";"+LEFT(ALLTRIM(kad.Ort),30)+; 			&& Ort
                ";"+THISFORM.GetString(kad.lkz,2)+;			&& Lnderkennzeichen
                ";"+;										&& Anrede Schlssel
                ";"+LEFT(ALLTRIM(kad.anrede),40)+; 			&& Anrede individuell
                ";"+";"+;									&& Titel, Zustellzusatz
                ";"+LEFT(TRANSFORM(kad.debnum),9)+ ;		&& Kundennummer (nochmal Debitorennummer)
                ";"+;										&& Sprache
                ";"+LEFT(ALLTRIM(kad.telefon),20)+; 		&& Telefon
                ";"+LEFT(ALLTRIM(kad.telefax),20)+; 		&& Telefax
                ";"+;										&& Mobiltelefon (bei CP-Pro nur im Ansprechpartner!)
                ";"+LEFT(ALLTRIM(kad.email),60)+; 			&& E-Mail
                ";"+LEFT(ALLTRIM(kad.homepage),60)+; 		&& Internet-URL
                ";"+;										&& Flligkeit in Tagen (aus ZB)
                ";"+;										&& Skonto in % (aus ZB)
                ";"+;										&& Datev Zahlungsbedingung (aus ZB)
                ";"+LEFT(kad.mschl,1)+;						&& Mahnschlssel
                ";"+TRANSFORM(kad.mlimit)+;					&& Mahnlimit Betrag
                ";"+;										&& Mahnlimit Prozent
                ";"+LEFT(kad.zinsber,1)+;					&& Zinsberechnung
                ";"+TRANSFORM(kad.zinsen1)+;				&& Zinsen ab 1. Mahnung
                ";"+TRANSFORM(kad.zinsen2)+;				&& Zinsen ab 2. Mahnung
                ";"+TRANSFORM(kad.zinsen3)+;				&& Zinsen ab 3. Mahnung
                ";"+LEFT(kad.dtvtxt1,1)+;					&& Mahntext 1.Mahnung
                ";"+LEFT(kad.dtvtxt2,1)+;					&& Mahntext 2.Mahnung
                ";"+LEFT(kad.dtvtxt3,1);					&& Mahntext 3.Mahnung
                )
            ENDSCAN

            USE IN SELECT("kad")
        ENDIF

        THIS.fileClose()

        SET COLLATE TO "GERMAN"

        RETURN lnError
    ENDFUNC

    FUNCTION doExport_KRED(tnId, tcFile)
        LOCAL lnError
        lnError = THIS.fileOpen(tcFile)

        IF lnError = ERR_OK
            LOCAL lAlle
            lAlle = THISFORM.cntdate.check2.VALUE

            SET COLLATE TO "MACHINE"  && Sonst kommen manchmal nicht alle Daten raus

            IF THISFORM.cntStm.opt1.VALUE = 1
                _sqlexec(_s( ;
                    "SELECT * FROM kunden " + ;
                    "WHERE debnum <> 0 " + ;
                    "AND debnum IN " + ;
                    "(SELECT debnum FROM  Nurkopf " + ;
                    "WHERE Nurkopf.buchungsdatum >= {1} " + ;
                    "AND Nurkopf.buchungsdatum<= {2} " + ;
                    "AND (EVL(Nurkopf.verbucht, .NULL.) IS NULL OR {3} = .T.) " + ;
                    "AND Nurkopf.ok = .T.) " + ;
                    "ORDER BY debnum", ;
                    ldVon, ldBis, lAlle), ;
                    "kad")
            ELSE
                _sqlexec( ;
                    "SELECT * FROM kunden " + ;
                    "WHERE typ = 3 OR typ = 4 " + ;
                    "ORDER BY debnum", ;
                    "kad")
            ENDIF
            THIS.fileWriteLn(_("CP-Pro Kreditoren %s-%s", DTOC(ldVon), DTOC(ldBis)))

            GOTO TOP
            SCAN
                THIS.fileWriteLn(TRANSFORM(kad.debnum)+ ;	&& Debitorennummer
                ";"+ALLTRIM(STRTRAN(kad.suchname,";",","))) 	&& Suchname
            ENDSCAN

            USE IN SELECT("kad")
        ENDIF

        THIS.fileClose()

        SET COLLATE TO "GERMAN"

        RETURN lnError
    ENDFUNC
ENDDEF

DEFINE CLASS pluginDMS AS cPlugins OF plugins.fxp
    cValue   = "DATEV Unternehmen Online DMS" && Bitte ndern, bei Verwendung als externes Plugin!
    nValue   = 999
    cWorkDir = "DATEV\"

    PROCEDURE registerActions(toPlugin AS plugins OF plugins.prg)
        ** Special Bind siehe oApp.oPlugins.Execute("Aufmass2Excel")...
        toPlugin.register(THIS, THIS.cValue, "Execute", "DONOTHING_Execute")
    ENDPROC

    PROCEDURE releaseActions(toPlugin AS plugins OF plugins.prg)
        IF DODEFAULT(@toPlugin)
            toPlugin.unregister(THIS, THIS.cValue, "Execute")
        ENDIF
    ENDPROC

    PROCEDURE onDocument(tcaCursor AS _cabaseclass OF datacls.vcx, tcAction, tcFileOrContent, tcContentType, tnHistId, tnFlags)
        IF VARTYPE(tnHistId)$"N" ;
                AND tnHistId != 0 ;
                AND tnFlags == 0;
                AND UPPER(tcAction)$"EXPORT PRINT MAIL DRUCKER";
                AND tcaCursor.DATATYPE$"RECHKOPF"

            ** Export DATEV Unternehmen Online XML

            LOCAL loHead
            loHead = tcaCursor.scatterobject()

            _sqlexec(;
                _s("SELECT factordeb ";
                +  "  FROM kunden ";
                +  " WHERE knr = {1}";
                , loHead.knr1);
                , "curKunde")

            _sqlexec(;
                _s("SELECT TOP 1 datevkto ";
                +  "  FROM ktr ";
                +  " WHERE ktr = {1}";
                +  " ORDER BY JAHR DESC";
                , loHead.ktr);
                , "curKtr")

            LOCAL lcPoint
            lcPoint = SET("Point")

            SET POINT TO "."

            LOCAL lcDocument
            lcDocument = ""
            TEXT TO lcDocument NOSHOW TEXTMERGE
<?xml version="1.0" encoding="UTF-8"?>
<invoice generator_info="CP-Pro Software &amp; Services Clausen KG"
         generating_system="CP-Pro Gerstbau-Office 3"
         description="DATEV Import invoices"
         xml_data="Kopie nur zur Verbuchung berechtigt nicht zum Vorsteuerabzug"
         version="3.0"
         xsi:schemaLocation="http://xml.datev.de/bedi/tps/invoice/v030 Belegverwaltung_online_invoice_v030.xsd"
         xmlns="http://xml.datev.de/bedi/tps/invoice/v030"
         xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<!-- <histid><<tnHistId>></histid> -->
	<invoice_info invoice_date="<<LEFT(TTOC(loHead.datum, 3), 10)>>"
	              invoice_type="<<ICASE(loHead.arnum = 0, 'Rechnung', loHead.arnum >= 98, 'Schlussrechnung', 'Abschlagsrechnung')>>"
	              delivery_date="<<LEFT(TTOC(loHead.belegdatum, 3), 10)>>"
	              invoice_id="<<LTRIM(STR(loHead.rechnr, 10))>>" />

	<accounting_info account_no="<<ALLTRIM(LEFT(loHead.konto, 8))>>"
	                 cost_category_id="<<RIGHT(LTRIM(STR(loHead.ktr, 12)),8)>>"
	                 booking_text="<<this.encode(LEFT(ICASE(loHead.arnum=0,"ER",loHead.arnum>=98,"SR",TRANSFORM(loHead.arnum)+".AR")+" "+loHead.objekt,60))>>"/>

<<IIF(ISNULL(loHead.begdatum) AND ISNULL(loHead.begdatum), "<!--", "")>>
	<delivery_period <<IIF(!ISNULL(loHead.begdatum), [delivery_date_start="]+LEFT(TTOC(loHead.begdatum, 3), 10)+["], "")>>
	                 <<IIF(!ISNULL(loHead.begdatum), [delivery_date_end="]+LEFT(TTOC(loHead.aufmdatum, 3), 10)+["], "")>> />
<<IIF(ISNULL(loHead.begdatum) AND ISNULL(loHead.begdatum), "-->", "")>>

	<invoice_party>
	    <address street="<<this.encode(LEFT(ALLTRIM(RTRIM(loHead.kaddr1) + " " + loHead.kaddr2), 41))>>"
	             name="<<this.encode(LEFT(ALLTRIM(RTRIM(loHead.kanrede) + " " + loHead.kname), 50))>>"
	             zip="<<this.encode(ALLTRIM(loHead.kplz))>>"
	             city="<<this.encode(LEFT(ALLTRIM(loHead.kort), 30))>>"
	             party_id="<<LTRIM(STR(loHead.knr1, 10))>>" />

	    <booking_info_bp bp_account_no="<<ALLTRIM(RIGHT(EVL(ALLTRIM(curKunde.factordeb), ALLTRIM(curKtr.datevkto)), 10))>>"/>
	</invoice_party>

	<supplier_party vat_id="DE_USTID">
	    <address zip="Adresse Plz"
	             city="Adresse Ort"
	             name="Firmenname" />
	</supplier_party>

	<payment_conditions due_date="<<LEFT(TTOC(loHead.faellig, 3), 10)>>"
	                    payment_conditions_text="<<this.encode(loHead.zb)>>" />

	<invoice_item_list description_short="<<this.encode(LEFT(loHead.objekt, 40))>>"
	                   quantity="1.00">
		<price_line_amount tax="<<LTRIM(STR(loHead.ustproza, 10, 2))>>"
		                   net_price_line_amount="<<LTRIM(STR(loHead.netto, 12, 2))>>"
		                   currency="<<this.encode(loHead.currenc1)>>" />
	</invoice_item_list>

	<total_amount total_gross_amount_excluding_third-party_collection="<<LTRIM(STR(loHead.brutto, 12, 2))>>"
	              net_total_amount="<<LTRIM(STR(ROUND(loHead.netto, 2), 12, 2))>>"
	              currency="<<this.encode(loHead.currenc1)>>">
		<tax_line tax="<<LTRIM(STR(loHead.ustproza, 12, 2))>>"
		          tax_amount="<<LTRIM(STR(loHead.ustdm, 12, 2))>>"
		          currency="<<this.encode(loHead.currenc1)>>" />
	</total_amount>
</invoice>
            ENDTEXT

            SET POINT TO &lcPoint.

            USE IN SELECT("curKunde")

            IF EMPTY(lcDocument)
                MESSAGEBOX(;
                    _("Fehler beim Erzeugen der Export-Datei fr DATEV Unternehmen Online");
                    ,48, "DATEV Unternehmen Online")
            ELSE
                LOCAL lnDmsHistId
                tcaCursor.statusSave("DATEV ONLINE", _("DATEV Unternehmen Online"), 0, @lnDmsHistId, STRCONV(STRCONV(lcDocument, 1), 9), "XML")

                **************************************************************
                ** BITTEST(bitflag, 6) -> relevante Dateien fr DATEV-Online
                **
                ** BITTEST(bitflag, 5) == .T. -> DATEV-Online XML-File
                ** BITTEST(bitflag, 5) == .F. -> PDF-Export
                **************************************************************
                _sqlexec(_s("UPDATE dochist SET BITFLAG = BITFLAG + 32 + 64 WHERE histid = {1}", lnDmsHistId))
                _sqlexec(_s("UPDATE dochist SET BITFLAG = BITFLAG      + 64 WHERE histid = {1}", tnHistId))
            ENDIF
        ENDIF
    ENDPROC

    PROCEDURE IsEnabled()
        RETURN oParam.param02.DmsIsActivated
    ENDPROC

    FUNCTION encode(tcString)

        RETURN RTRIM(STRTRAN(STRTRAN(tcString, '&', '&amp;'), '"', '&quot;'))
    ENDFUNC
ENDDEF
